﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HUDOneRR
{
    class CRC
    {
        //========================================================================
        static public ushort Update(ushort crcIn, byte b)
        {
            ulong crc = crcIn;
            ulong i = (b | 0x100UL);

            do
            {
                crc <<= 1;
                i <<= 1;
                if ((i & 0x100U) == 0x100U)
                {
                    ++crc;
                }
                if ((crc & 0x10000U) == 0x10000U)
                {
                    crc ^= 0x1021U;
                }
            } while ((i & 0x10000U) == 0);

            return (ushort)(crc & 0xffffU);
        }

        //========================================================================
        static public ushort Calculate(byte[] data, int start, int len)
        {
            ushort crc = 0;

            for (int i = 0; i < len; ++i)
            {
                crc = Update(crc, data[start + i]);
            }

            crc = Update(crc, 0);
            crc = Update(crc, 0);

            return crc;
        }
    }
}
