﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Runtime.InteropServices;

namespace HUDOneRR
{
	#region RR SDK

	[ComVisible(false)]
	static public class SDK
	{
		static bool _Created;
		static object RRSDK;
		static Type objAddType;
		static bool _Enabled = true;

		static public void SetSDK()
		{
			try
			{
				objAddType = Type.GetTypeFromProgID("RideRunner.SDK");
				RRSDK = Activator.CreateInstance(objAddType);
				if (RRSDK != null)
				{
					_Created = true;

					_Enabled = true;
				}
			}
			catch 
			{
				// "Failed to create RideRunner SDK Com Interface"
			}
		}

		static public bool Created
		{
			get { return _Created; }
		}

		static public bool Enabled
		{
			 set { _Enabled = value; }
		}

		static public void DoLog(string message)
		{
			if (RRSDK == null)
				return;

			if (_Enabled == false)
				return;

			objAddType.InvokeMember("RRLog", BindingFlags.InvokeMethod, null, RRSDK, new object[] { message });
		}

		static public void Execute(string CMD)
		{
			if (RRSDK == null)
				return;

			if (_Enabled == false)
				return;

			objAddType.InvokeMember("Execute", BindingFlags.InvokeMethod, null, RRSDK, new object[] { CMD, false });
		}

		static public void Execute(string CMD, bool Wait)
		{
			if (RRSDK == null)
				return;

			if (_Enabled == false)
				return;

			objAddType.InvokeMember("Execute", BindingFlags.InvokeMethod, null, RRSDK, new object[] { CMD, Wait });
		}

		static public string GetInfo(string inf)
		{
			if (RRSDK == null)
				return null;

			return (string)objAddType.InvokeMember("GetInfo", BindingFlags.InvokeMethod, null, RRSDK, new object[] { inf, "" });
		}

		static public string GetInfo(string inf, string FMT)
		{
			if (RRSDK == null)
				return null;

			if (_Enabled == false)
				return null;

			return (string)objAddType.InvokeMember("GetInfo", BindingFlags.InvokeMethod, null, RRSDK, new object[] { inf, FMT });
		}

		static public string GetInd(string ind)
		{
			if (RRSDK == null)
				return null;

			if (_Enabled == false)
				return null;

			return (string)objAddType.InvokeMember("GetInd", BindingFlags.InvokeMethod, null, RRSDK, new object[] { ind, "" });
		}

		static public string GetInd(string ind, string SCR)
		{
			if (RRSDK == null)
				return null;

			if (_Enabled == false)
				return null;

			return (string)objAddType.InvokeMember("GetInd", BindingFlags.InvokeMethod, null, RRSDK, new object[] { ind, SCR });
		}

		static public void ErrScrn(string Title, string Subject, string Message, int Timeout)
		{
			if (RRSDK == null)
				return;

			if (_Enabled == false)
				return;

			objAddType.InvokeMember("ErrScrn", BindingFlags.InvokeMethod, null, RRSDK, new object[] { Title, Subject, Message, Timeout });
		}

		static public void ErrScrn(string Title, string Subject, string Message)
		{
			SDK.ErrScrn(Title, Subject, Message, (int)-1);
		}

		static public void SetUserVar(string userVariable, string value)
		{
			if (RRSDK == null)
				return;

			if (_Enabled == false)
				return;

			objAddType.InvokeMember("SetUserVar", BindingFlags.InvokeMethod, null, RRSDK, new object[] { userVariable, value });
		}

		static public string GetUserVar(string userVariable)
		{
			if (RRSDK == null)
				return null;

			if (_Enabled == false)
				return null;

			return (string)objAddType.InvokeMember("GetUserVar", BindingFlags.InvokeMethod, null, RRSDK, new object[] { userVariable });
		}

		static public void AddRepeatCMD(string command)
		{
			if (RRSDK == null)
				return;

			if (_Enabled == false)
				return;

			objAddType.InvokeMember("AddRepeatCMD", BindingFlags.InvokeMethod, null, RRSDK, new object[] { command });
		}
	}
	#endregion
}
